const http = require('http');
const url = require('url');
const fs = require('fs');
const ws = require('ws');

http.createServer(function (req, res) {
  const q = url.parse(req.url, true);
  let filename = "./public" + q.pathname;
  if (filename === "./public/") filename = "./public/index.html";
  fs.readFile(filename, function(err, data) {
    if (err) {
      res.writeHead(404, {'Content-Type': 'text/html'});
      return res.end("404 Not Found");
    }
    res.writeHead(200, {'Content-Type': 'text/html'});
    res.write(data);
    return res.end();
  });
}).listen(8080);

const wss = new ws.Server({
  port: 8081,
  perMessageDeflate: {
    zlibDeflateOptions: {
      // See zlib defaults.
      chunkSize: 1024,
      memLevel: 7,
      level: 3
    },
    zlibInflateOptions: {
      chunkSize: 10 * 1024
    },
    // Other options settable:
    clientNoContextTakeover: true, // Defaults to negotiated value.
    serverNoContextTakeover: true, // Defaults to negotiated value.
    serverMaxWindowBits: 10, // Defaults to negotiated value.
    // Below options specified as default values.
    concurrencyLimit: 10, // Limits zlib concurrency for perf.
    threshold: 1024 // Size (in bytes) below which messages
    // should not be compressed.
  }
});

wss.on('connection', ws => {
  ws.on('message', message => {
    console.log(`Received message => ${message}`)
    if ({message} == 'long_url ') ws.send('error: url is empty')
  })
  ws.send('websocket connected')
})
